#include<iostream>
using namespace std;

// automatische Typumwandlung

class KomplexeZahl // gibts besser in der Standardbibliothek
{
    private:
    double re, im;

    public:
    KomplexeZahl(double r, double i) :
    re(r), im(i)
    { }

    KomplexeZahl(double r) :    // knnte man auch oben mit Default-Parameter erreichen
    re(r), im(0)
    { }

    void drucke(void)
    {
        cout <<  re << " " << im << endl;
    }
};

void druckeKomplexeZahl(KomplexeZahl z)
{
    z.drucke();
}

int main ( int argc, char* (argv[]) )
{
    KomplexeZahl u(1.2, 3.4);
    druckeKomplexeZahl(u);

    double a = 3.14;
    druckeKomplexeZahl(a); // Automatische Konvertierung mittels Konstruktor!
                           // Funkt gerne mal dazwischen, dann die Automatik
                           // verbieten durch "explicit" bei Konstruktordeklaration.
    return 0;
}


// Andere Art der Konvertierung: Die Quellklasse konvertiert, nicht die Zielklasse.
// Geht natrlich nicht bei eingebauten Typen.

class ReelleZahl
{
    private:
    double re;

    public:
    ReelleZahl(double r) :
    re(r)
    { }

    operator KomplexeZahl() const
    {
        return KomplexeZahl(re);
    }
};

void test(void)
{
    ReelleZahl a(3.14);
    druckeKomplexeZahl(a);
}
